## racket 7.2+dfsg1

=== src/cs/Makefile ===
# This makefile is used to a limited degree with nmake, but it mostly
# intended for use as a GNU makefile.

RACKET = ../../bin/racket
SCHEME = scheme

# Controls whether Racket layers are built as unsafe:
UNSAFE_COMP = --unsafe

# Controls whether compiled code is compressed:
COMPRESS_COMP = # --compress

# Controls whether Racket layers are built with expression-level debugging:
DEBUG_COMP = # --debug

COMPILE_FILE = $(SCHEME) --script compile-file.ss $(UNSAFE_COMP) $(COMPRESS_COMP) $(DEBUG_COMP) --dest "$(BUILDDIR)"
COMPILE_FILE_DEPS = compile-file.ss include.ss place-register.ss 

RACKET_SETUP_ARGS = ../../bin/racket ../../bin/racket ../collects ../etc 0 true false 0 ""

PRIMITIVES_TABLES = primitive/kernel.ss primitive/unsafe.ss primitive/flfxnum.ss \
                    primitive/paramz.ss primitive/extfl.ss primitive/network.ss \
                    primitive/futures.ss primitive/foreign.ss primitive/place.ss \
                    primitive/linklet.ss primitive/internal.ss

# Set by the makefile in the "c" directory when driving this one
BUILDDIR = 

# List all targets ".scm" that use "convert.rkt" so we can generate a
# dependency rule for all of them:
CONVERTED = $(BUILDDIR)compiled/thread.scm $(BUILDDIR)compiled/io.scm \
            $(BUILDDIR)compiled/regexp.scm $(BUILDDIR)compiled/expander.scm \
            $(BUILDDIR)compiled/schemify.scm $(BUILDDIR)compiled/known.scm

# Additional dependencies for those ".scm" files generated by "convert.rkt":
CONVERT_DEPS = $(PRIMITIVES_TABLES)

CONVERT_RACKET = $(RACKET) -l- setup --chain ../setup-go.rkt $(BUILDDIR)compiled
CONVERT = $(CONVERT_RACKET) '(CONVERTED)' $(BUILDDIR)compiled/convert.d convert.rkt $(UNSAFE_COMP)

# Depenency chain for ".so" files:
RUMBLE_DEPS = $(BUILDDIR)chezpart.so
THREAD_DEPS = $(RUMBLE_DEPS) $(BUILDDIR)rumble.so
IO_DEPS = $(THREAD_DEPS) $(BUILDDIR)thread.so
REGEXP_DEPS = $(IO_DEPS) $(BUILDDIR)io.so
SCHEMIFY_DEPS = $(REGEXP_DEPS) $(BUILDDIR)regexp.so
LINKLET_DEPS = $(SCHEMIFY_DEPS) $(BUILDDIR)schemify.so
EXPANDER_DEPS = $(LINKLET_DEPS) $(BUILDDIR)linklet.so
MAIN_DEPS = $(EXPANDER_DEPS) $(BUILDDIR)expander.so

all:
	$(MAKE) rktio
	$(MAKE) rktl
	$(MAKE) $(BUILDDIR)racket.so

expander-demo: $(BUILDDIR)expander.so demo/expander.ss ../../bin/racket
	$(SCHEME) $(EXPANDER_DEPS) $(BUILDDIR)expander.so demo/expander.ss

run: $(BUILDDIR)main.so ../../bin/racket
	$(SCHEME) --script $(BUILDDIR)main.so $(RACKET_SETUP_ARGS) $(ARGS)

setup:
	$(MAKE) run ARGS="-l- setup $(ARGS)"

setup-v:
	$(MAKE) run ARGS="-W 'info@compiler/cm info@linklet debug@GC:major error' -l- setup -j 1 $(ARGS)"

run-wpo: $(BUILDDIR)racket.so ../../bin/racket
	$(SCHEME) --script $(BUILDDIR)racket.so $(RACKET_SETUP_ARGS) $(ARGS)

$(BUILDDIR)racket.so: $(BUILDDIR)main.so $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) --whole-program $(BUILDDIR)racket.so $(BUILDDIR)main.wpo

$(BUILDDIR)main.so: $(MAIN_DEPS) main.sps $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) main.sps $(MAIN_DEPS)

strip:
	$(SCHEME) --script strip.ss $(MAIN_DEPS) $(BUILDDIR)racket.so

rktl:
	$(MAKE) thread-rktl
	$(MAKE) io-rktl
	$(MAKE) regexp-rktl
	$(MAKE) schemify-rktl
	$(MAKE) known-rktl
	$(MAKE) expander-rktl

# For running without an enclosing build of the traditional Racket VM:
../../bin/racket:
	mkdir -p ../../bin
	touch ../../bin/racket

$(BUILDDIR)expander.so: expander.sls $(BUILDDIR)compiled/expander.scm $(PRIMITIVES_TABLES) $(EXPANDER_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) expander.sls $(EXPANDER_DEPS)

$(BUILDDIR)compiled/expander.scm: $(BUILDDIR)compiled/expander.rktl $(CONVERT_DEPS)
	$(CONVERT) $(BUILDDIR)compiled/expander.rktl $(BUILDDIR)compiled/expander.scm

$(BUILDDIR)compiled/expander.rktl:
	$(MAKE) expander-rktl

expander-rktl:
	$(MAKE) bounce BOUNCE_DIR=../expander BOUNCE_TARGET=expander-src BUILDDIR="../cs/"

linklet-demo: $(BUILDDIR)linklet.so
	$(SCHEME) $(LINKLET_DEPS) $(BUILDDIR)linklet.so demo/linklet.ss

LINKLET_SRCS = linklet/read.ss \
               linklet/write.ss \
               linklet/performance.ss \
               linklet/annotation.ss \
               linklet/compress.ss \
               linklet/db.ss

$(BUILDDIR)linklet.so: linklet.sls $(LINKLET_SRCS) $(LINKLET_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) linklet.sls $(LINKLET_DEPS)


$(BUILDDIR)schemify.so: schemify.sls $(BUILDDIR)compiled/schemify.scm $(BUILDDIR)compiled/known.scm $(SCHEMIFY_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) schemify.sls $(SCHEMIFY_DEPS)

$(BUILDDIR)compiled/schemify.scm: $(BUILDDIR)compiled/schemify.rktl $(CONVERT_DEPS)
	$(CONVERT) --skip-export $(BUILDDIR)compiled/schemify.rktl $(BUILDDIR)compiled/schemify.scm

$(BUILDDIR)compiled/schemify.rktl:
	$(MAKE) schemify-rktl

schemify-rktl:
	$(MAKE) bounce BOUNCE_DIR=../schemify BOUNCE_TARGET=schemify-src BUILDDIR="../cs/"


# Used by schemify.sls at compile time
$(BUILDDIR)compiled/known.scm: $(BUILDDIR)compiled/known.rktl $(CONVERT_DEPS)
	$(CONVERT) --skip-export $(BUILDDIR)compiled/known.rktl $(BUILDDIR)compiled/known.scm

$(BUILDDIR)compiled/known.rktl:
	$(MAKE) known-rktl

known-rktl:
	$(MAKE) bounce BOUNCE_DIR=../schemify BOUNCE_TARGET=known-src BUILDDIR="../cs/"


regexp-demo: $(BUILDDIR)regexp.so
	$(SCHEME) $(REGEXP_DEPS) $(BUILDDIR)regexp.so demo/regexp.ss

$(BUILDDIR)regexp.so: $(BUILDDIR)compiled/regexp.scm regexp.sls $(REGEXP_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) regexp.sls $(REGEXP_DEPS)

$(BUILDDIR)compiled/regexp.scm: $(BUILDDIR)compiled/regexp.rktl $(CONVERT_DEPS)
	$(CONVERT) $(BUILDDIR)compiled/regexp.rktl $(BUILDDIR)compiled/regexp.scm

$(BUILDDIR)compiled/regexp.rktl:
	$(MAKE) regexp-rktl

regexp-rktl:
	$(MAKE) bounce BOUNCE_DIR=../regexp BOUNCE_TARGET=regexp-src BUILDDIR="../cs/"


io-demo: $(BUILDDIR)io.so
	$(SCHEME) $(IO_DEPS) $(BUILDDIR)io.so demo/io.ss

$(BUILDDIR)io.so: $(BUILDDIR)compiled/io.scm io.sls $(IO_DEPS) ../rktio/rktio.rktl $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) io.sls $(IO_DEPS)

$(BUILDDIR)compiled/io.scm: $(BUILDDIR)compiled/io.rktl $(CONVERT_DEPS)
	$(CONVERT) $(BUILDDIR)compiled/io.rktl $(BUILDDIR)compiled/io.scm

$(BUILDDIR)compiled/io.rktl:
	$(MAKE) io-rktl

io-rktl:
	$(MAKE) bounce BOUNCE_DIR=../io BOUNCE_TARGET=io-src BUILDDIR="../cs/"

rktio:
	$(MAKE) bounce BOUNCE_DIR=../io BOUNCE_TARGET=rktio


thread-demo: $(BUILDDIR)thread.so
	$(SCHEME) $(THREAD_DEPS) $(BUILDDIR)thread.so demo/thread.ss

$(BUILDDIR)thread.so: $(BUILDDIR)compiled/thread.scm thread.sls $(THREAD_DEPS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) thread.sls $(THREAD_DEPS)

$(BUILDDIR)compiled/thread.scm: $(BUILDDIR)compiled/thread.rktl $(CONVERT_DEPS)
	$(CONVERT) $(BUILDDIR)compiled/thread.rktl $(BUILDDIR)compiled/thread.scm

$(BUILDDIR)compiled/thread.rktl:
	$(MAKE) thread-rktl

thread-rktl:
	$(MAKE) bounce BOUNCE_DIR=../thread BOUNCE_TARGET=thread-src BUILDDIR="../cs/"


bounce:
	$(MAKE) bounce-go RACKET="`$(RACKET) absify.rkt --exec $(RACKET)`"

bounce-go:
	cd $(BOUNCE_DIR); $(MAKE) RACO="$(RACKET) -N raco -l- raco" $(BOUNCE_TARGET)


chaperone-demo: $(BUILDDIR)rumble.so
	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/chaperone.ss

hash-demo: $(BUILDDIR)rumble.so
	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/hash.ss

struct-demo: $(BUILDDIR)rumble.so
	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/struct.ss

control-demo: $(BUILDDIR)rumble.so
	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/control.ss

foreign-demo: $(BUILDDIR)rumble.so
	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/foreign.ss

will-demo: $(BUILDDIR)rumble.so
	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/will.ss

future-demo: $(BUILDDIR)rumble.so
	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/future.ss

future2-demo: $(BUILDDIR)rumble.so
	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/future2.ss

RUMBLE_SRCS = rumble/define.ss \
              rumble/virtual-register.ss \
              rumble/check.ss \
	      rumble/syntax-rule.ss \
	      rumble/letrec.ss \
              rumble/constant.ss \
              rumble/hash-code.ss \
              rumble/struct.ss \
              rumble/prefab.ss \
              rumble/procedure.ss \
              rumble/impersonator.ss \
              rumble/equal.ss \
              rumble/object-name.ss \
              rumble/arity.ss \
              rumble/intmap.ss \
              rumble/hash.ss \
              rumble/datum.ss \
	      rumble/lock.ss \
	      rumble/thread-local.ss \
              rumble/thread-cell.ss \
              rumble/parameter.ss \
              rumble/begin0.ss \
              rumble/pthread.ss \
              rumble/control.ss \
              rumble/interrupt.ss \
              rumble/engine.ss \
              rumble/source.ss \
              rumble/error.ss \
              rumble/srcloc.ss \
              rumble/boolean.ss \
              rumble/bytes.ss \
              rumble/string.ss \
              rumble/char.ss \
              rumble/symbol.ss \
              rumble/list.ss \
              rumble/vector.ss \
              rumble/box.ss \
              rumble/immutable.ss \
              rumble/keyword.ss \
              rumble/mpair.ss \
              rumble/number.ss \
              rumble/random.ss \
              rumble/flvector.ss \
              rumble/correlated.ss \
              rumble/graph.ss \
              rumble/time.ss \
              rumble/memory.ss \
              rumble/ephemeron.ss \
              rumble/will-executor.ss \
              rumble/system.ss \
              rumble/unsafe.ss \
              rumble/extfl.ss \
              rumble/place.ss \
              rumble/errno-data.ss \
              rumble/foreign.ss \
              rumble/future.ss \
              rumble/version.ss \
              rumble/inline.ss \
              ../racket/src/schvers.h

$(BUILDDIR)rumble.so: $(RUMBLE_DEPS) rumble.sls $(RUMBLE_SRCS) $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) rumble.sls $(RUMBLE_DEPS)

$(BUILDDIR)chezpart.so: chezpart.sls $(COMPILE_FILE_DEPS)
	$(COMPILE_FILE) chezpart.sls

clean:
	rm -f chezpart.so rumble.so regexp.so io.so linklet.so expander.so schemify.so
	rm -f chezpart.wpo rumble.wpo regexp.wpo io.wpo linklet.wpo expander.wpo schemify.wpo
	rm -f thread.so thread.wpo main.wpo main.so
	rm -rf compiled


# The following included dependency files are generated by when
# creating compiler/expander.rktl, etc. The `-inclide` statements are
# wrapped in a pattern that causes them to be ignored by `nmake`,
# while the `nmake` directives are ignored by GNU `make`.

# \
!if 0

# These dependencies are used only for direct use of the makefile
-include compiled/expander.d
-include compiled/thread.d
-include compiled/io.d
-include compiled/regexp.d
-include compiled/schemify.d
-include compiled/known.d

# These dependencies are needed when "cs/c" drives the makefile
-include $(BUILDDIR)compiled/convert.d

#\
!endif

# \
!include $(BUILDDIR)compiled/convert.d

=== src/expander/Makefile ===
# This makefile can be used directly, in which case it writes to a
# "compiled" subdirectory, or it can be driven by other makefiles that
# redirect to a different build dierctory by setting `BUILDDIR` and
# other variables.

# Beware that this makefile is used both for GNU make and for nmake!

RACKET = ../../bin/racket
RACO = $(RACKET) -N raco -l- raco

# Tree for collections:
TREE = ../..

# See "boot/read-primitive.rkt" for more info:
KNOT = ++knot read read/api.rkt \
       ++knot read read/primitive-parameter.rkt \
       ++knot read read/readtable-parameter.rkt \
       ++knot read read/readtable.rkt \
       ++knot read read/number.rkt

# When flattening, replace a dynamic lookup from a primitive table to
# a direct use of the primitive name:
DIRECT = ++direct linklet ++direct kernel

# Make sure that the flattened form doesn't use
# `make-optional-keyword-procedure`:
DISALLOW = ++disallow make-optional-keyword-procedure

# Enable the sanity check for global state (to be avoided in
# favor of place-local state), but declare some initialized-once
# global state to be ok:
GLOBALS = --no-global \
          ++global-ok core-forms \
          ++global-ok core-primitives \
          ++global-ok built-in-symbols \
          ++global-ok default-read-handler \
          ++global-ok current-previously-unbound \
          ++global-ok "keep-source-locations?" \
          ++global-ok rx:path-list

# Set `BUILDDIR` as a prefix on "compiled" output (defaults to empty).
# Set `DEPENDSDIR` as the same sort of prefix in the generated
# makefile-dependency file (also defaults to empty). The `BUILDDIR`
# and `DEPENDSDIR` settings are different, because `BUILDDIR` is
# relative to here, while makefile dependencies may be needed relative
# to makefile driving the one.

expander:
	$(RACO) make bootstrap-run.rkt
	$(RACKET) bootstrap-run.rkt -c compiled/cache-src $(KNOT) $(DIRECT) $(DISALLOW) $(GLOBALS) --local-rename -O $(TREE)

expander-src:
	$(RACO) make bootstrap-run.rkt
	$(MAKE) expander-src-generate

GENERATE_ARGS = -c $(BUILDDIR)compiled/cache-src \
                --check-depends $(BUILDDIR)compiled/expander-dep.rktd \
                ++depend-module bootstrap-run.rkt \
                --depends $(BUILDDIR)compiled/expander-dep.rktd \
                --makefile-depends $(DEPENDSDIR)compiled/expander.rktl $(BUILDDIR)compiled/expander.d \
                $(KNOT) $(DIRECT) $(DISALLOW) $(GLOBALS) -k $(TREE) -s -x \
                -o $(BUILDDIR)compiled/expander.rktl

# This target can be used with a `RACKET` that builds via `-l- setup --chain ...`
expander-src-generate:
	$(RACKET) bootstrap-run.rkt $(GENERATE_ARGS)

demo:
	$(RACO) make demo.rkt
	$(RACKET) demo.rkt

run:
	$(RACO) make run.rkt
	$(RACKET) $(RKT_ARGS) run.rkt -c compiled/cache $(ARGS)

# Like `run`, but with source as compiled (as used for flattening)
run-src:
	$(RACO) make bootstrap-run.rkt
	$(RACKET) $(RKT_ARGS) bootstrap-run.rkt -s -c compiled/cache-src $(ARGS)

# Like `run`, but without using a cache for expanded and compiled linklets
run-no-cache:
	$(RACO) make run.rkt
	$(RACKET) $(RKT_ARGS) run.rkt $(ARGS)

# Writes the extracted, compiled, decompiled expander to compiled/exp.rkt
decompile:
	$(RACO) make bootstrap-run.rkt
	$(RACKET) $(RKT_ARGS) bootstrap-run.rkt -c compiled/cache-src $(KNOT) -s -x -D -o compiled/exp.rkt

# Writes the extracted, compiled expander to compiled/exp.zo
bytecode:
	$(RACO) make bootstrap-run.rkt
	$(RACKET) $(RKT_ARGS) bootstrap-run.rkt -c compiled/cache-src $(KNOT) -s -x -B -o compiled/exp.zo

.PHONY: expander expander-src expander-src-generate demo run run-no-cache

=== src/io/Makefile ===
# This makefile can be used directly or driven by other makefiles.
# See "../expander/Makefile" for more notes.

RACKET = ../../bin/racket
RACO = $(RACKET) -N raco -l- raco

# Can be set to empty to avoid building rktio
RKTIO_DEP=../build/so-rktio/Makefile

# When flattening, replace a dynamic lookup from a primitive table to
# a direct use of the primitive name:
DIRECT = ++direct thread ++direct pthread

# Enable the sanity check for global state (to be avoided in
# favor of place-local state), but declare some initialized-once
# global state to be ok:
GLOBALS = --no-global \
          ++global-ok installed-read \
          ++global-ok installed-read-syntax \
          ++global-ok installed-read-accept-reader \
          ++global-ok installed-read-accept-lang \
          ++global-ok maybe-raise-missing-module \
          ++global-ok "string->number?" \
          ++global-ok "printable-regexp?" \
          ++global-ok do-global-print \
          ++global-ok simplify-path/dl \
          ++global-ok exec-file \
          ++global-ok run-file \
          ++global-ok collects-dir \
          ++global-ok config-dir \
          ++global-ok addon-dir

io-src: $(RKTIO_DEP)
	$(RACO) make ../expander/bootstrap-run.rkt
	$(MAKE) io-src-generate

GENERATE_ARGS = -t main.rkt --submod main \
                --check-depends $(BUILDDIR)compiled/io-dep.rktd \
                ++depend-module ../expander/bootstrap-run.rkt \
                ++depend ../rktio/rktio.rktl \
                --depends $(BUILDDIR)compiled/io-dep.rktd \
                --makefile-depends $(DEPENDSDIR)compiled/io.rktl $(BUILDDIR)compiled/io.d \
                -c $(BUILDDIR)compiled/cache-src \
                -k ../.. -s -x $(DIRECT) $(GLOBALS) \
                -o $(BUILDDIR)compiled/io.rktl

# This target can be used with a `RACKET` that builds via `-l- setup --chain ...`
io-src-generate:
	$(RACKET) ../expander/bootstrap-run.rkt $(GENERATE_ARGS)

demo: $(RKTIO_DEP)
	$(RACO) make demo.rkt
	$(RACKET) demo.rkt

demo-thread: $(RKTIO_DEP)
	$(RACO) make demo-thread.rkt
	$(RACKET) demo-thread.rkt


../build/so-rktio/Makefile: ../rktio/configure ../rktio/Makefile.in ../rktio/rktio_config.h.in
	mkdir -p ../build/so-rktio
	$(MAKE) build-rktio RACKET="`$(RACKET) ../cs/absify.rkt --exec $(RACKET)`" PREFIX="`$(RACKET) ../cs/absify.rkt ../..`"

build-rktio:
	cd ../build/so-rktio; ../../rktio/configure --enable-standalone --prefix=$(PREFIX)
	cd ../build/so-rktio; make install-shared-object


.PHONY: io-src io-src-generate demo rktio build-rktio

=== src/schemify/Makefile ===
# This makefile can be used directly or driven by other makefiles.
# See "../expander/Makefile" for more notes.

RACKET = ../../bin/racket
RACO = $(RACKET) -N raco -l- raco

# Ignoring functions from `#%read` works beause they won't appear in
# the simplified expansion. Make annotation references direct to
# improve performance. Declaring "collect.rkt" pure works around a
# limitation of the flattener.
IGNORE = ++knot read - ++direct kernel ++pure ../../collects/racket/private/collect.rkt

schemify-src:
	$(RACO) make ../expander/bootstrap-run.rkt
	$(MAKE) schemify-src-generate

known-src:
	$(RACO) make ../expander/bootstrap-run.rkt
	$(MAKE) known-src-generate


S_GENERATE_ARGS = -t main.rkt \
                  --check-depends $(BUILDDIR)compiled/schemify-dep.rktd \
                  ++depend-module ../expander/bootstrap-run.rkt \
                  --depends $(BUILDDIR)compiled/schemify-dep.rktd \
                  --makefile-depends $(DEPENDSDIR)compiled/schemify.rktl $(BUILDDIR)compiled/schemify.d \
                  -c $(BUILDDIR)compiled/cache-src \
                  -k ../.. $(IGNORE) -s -x \
                  -o $(BUILDDIR)compiled/schemify.rktl

schemify-src-generate:
	$(RACKET) ../expander/bootstrap-run.rkt $(S_GENERATE_ARGS)


K_GENERATE_ARGS = -t known.rkt \
                  --check-depends $(BUILDDIR)compiled/known-dep.rktd \
                  ++depend-module ../expander/bootstrap-run.rkt \
                  --depends $(BUILDDIR)compiled/known-dep.rktd \
                  --makefile-depends $(DEPENDSDIR)compiled/known.rktl $(BUILDDIR)compiled/known.d \
                  -c $(BUILDDIR)compiled/cache-src \
                  -k ../.. $(IGNORE) -s -x \
                  -o $(BUILDDIR)compiled/known.rktl


known-src-generate:
	$(RACKET) ../expander/bootstrap-run.rkt $(K_GENERATE_ARGS)

.PHONY: schemify-src schemify-src-generate known-src known-src-generate

=== src/worksp/cs/Makefile ===

INCS = /I.. /I..\..\rktio /I..\librktio /I$(SCHEME_DIR)\$(MACHINE)\boot\$(MACHINE)

RKTIO_LIB = ..\..\build\librktio.lib
BASE_WIN32_LIBS = WS2_32.lib Shell32.lib User32.lib
WIN32_LIBS = $(BASE_WIN32_LIBS) RpCrt4.lib Ole32.lib Advapi32.lib
SCHEME_LIB_FULL = $(SCHEME_DIR)\$(MACHINE)\boot\$(MACHINE)\$(SCHEME_LIB)

LIBS = $(RKTIO_LIB) \
       $(SCHEME_LIB_FULL) \
       $(WIN32_LIBS)

DEST_DLL = ..\..\build\raw_libracketcs.dll
DEST = ..\..\build\raw_racketcs.exe
GDEST = ..\..\build\raw_gracketcs.exe
CSDIR = ..\..\cs\c

MAIN_DEPS = ..\..\start\config.inc \
            ..\..\start\parse_cmdl.inc \
            ..\..\start\delayed.inc \
            ..\..\start\win_single.inc \
            ..\..\start\embedded_dll.inc

MEMMOD = ..\..\start\MemoryModule.c

FLAGS = /DWIN32 /Ox /MT
COMP_SUBDIR = /DCS_COMPILED_SUBDIR=1

all: $(DEST) $(GDEST)

$(DEST_DLL): $(CSDIR)\boot.c libracket.res $(RKTIO_LIB) $(SCHEME_LIB_FULL)
	cl /LD /DLL /Fe$(DEST_DLL) $(FLAGS) $(INCS) $(CSDIR)\boot.c libracket.res $(LIBS)

libracket.res: libracket.rc
	rc /l 0x409 /folibracket.res libracket.rc

$(DEST): $(CSDIR)\main.c $(MAIN_DEPS) $(MEMMOD) $(DEST_DLL) racket.res
	cl /Fe$(DEST) $(COMP_SUBDIR) $(FLAGS) $(INCS) $(CSDIR)\main.c $(MEMMOD) racket.res $(WIN32_LIBS)

racket.res: ../racket/racket.rc ../racket/racket.ico
	rc /l 0x409 /foracket.res ../racket/racket.rc

$(GDEST): $(CSDIR)\grmain.c $(CSDIR)\main.c $(MAIN_DEPS) $(DEST_DLL) gracket.res
	cl /Fe$(GDEST) $(COMP_SUBDIR) $(FLAGS) $(INCS) $(CSDIR)\grmain.c $(MEMMOD) gracket.res $(WIN32_LIBS)

gracket.res: ../gracket/gracket.rc ../gracket/gracket.ico
	rc /l 0x409 /fogracket.res ../gracket/gracket.rc

# Useful for debugging:

RKTIO_DLL = ..\..\lib\librktio.dll

rktio-dll:
	cl /Fe$(RKTIO_DLL) /LD $(RKTIO_LIB) $(BASE_WIN32_LIBS) ..\..\rktio\rktio.def /link /machine:x64

=== debian/changelog ===
racket (7.2+dfsg1-2ubuntu3) focal; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 15 Jan 2020 18:24:43 +0100

racket (7.2+dfsg1-2ubuntu2) eoan; urgency=medium

  * Really set cflags in a way that cdbs will see them.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 27 Aug 2019 17:55:23 -0700

racket (7.2+dfsg1-2ubuntu1) eoan; urgency=medium

  * Ensure building with -O2 to work around a misbuild on ppc64el which
    defaults to -O3.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 27 Aug 2019 17:11:35 -0700

racket (7.2+dfsg1-2) unstable; urgency=medium

  * Upload to unstable.

 -- David Bremner <bremner@debian.org>  Tue, 19 Feb 2019 17:11:01 -0400

racket (7.2+dfsg1-1) experimental; urgency=medium

  * New upstream bugfix release.
  * Bug fix: "Install Package doesn't work in DrRacket", thanks to
    Mike Manilone (Closes: #922444).

 -- David Bremner <bremner@debian.org>  Sat, 16 Feb 2019 20:59:49 -0400

=== debian/control ===
Source: racket
Section: lisp
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: David Bremner <bremner@debian.org>
Standards-Version: 4.1.1
Build-Depends: cdbs, debhelper (>= 10), patchutils, libffi-dev,
 libfreetype6-dev, libjpeg-dev, libpango1.0-dev, libpng-dev, libssl-dev,
 libxaw7-dev, xbitmaps, libxft-dev, libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev, libx11-dev, libxrender-dev, libcairo2-dev,
 sqlite3
Vcs-Git: https://salsa.debian.org/bremner/racket
Vcs-Browser: https://salsa.debian.org/bremner/racket
Homepage: https://www.racket-lang.org/

Package: racket
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, racket-common (= ${source:Version})
Recommends: racket-doc (>= ${source:Upstream-Version}),
            libglib2.0-0, libpangocairo-1.0-0, libjpeg62-turbo, libpng16-16,
            libgtk2.0-0, libgdk-pixbuf2.0-0, libssl1.1
Breaks: plt-scheme (<<5.0~)
Replaces: plt-scheme (<<5.0~)
Provides: plt-scheme
Description: extensible programming language in the Scheme family
 Racket (previously PLT Scheme) is a programming language suitable for
 scripting and application development, including GUIs and web
 services.
 .
 It supports the creation of new programming languages through a rich,
 expressive syntax system. Supplied languages include Typed Racket,
 ACL2, FrTime, and Lazy Racket, and R6RS Scheme.
 .
 Racket includes the DrRacket programming environment, a virtual
 machine with a just-in-time compiler, tools for creating stand-alone
 executables, the Racket web server, extensive libraries, and
 documentation for both beginners and experts.

Package: racket-common
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: racket (>= ${source:Upstream-Version})
            , racket-doc (>= ${source:Upstream-Version})
            , sensible-utils
Breaks: plt-scheme (<<5.0~), racket-doc (<<6.1~)
Replaces: plt-scheme (<<5.0~), racket-doc (<<6.1~)
Description: extensible programming language in the Scheme family (shared files)
 This package includes the architecture independent files for Racket
 (but not the documentation, see racket-doc for that).

Package: racket-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: racket (>= ${source:Upstream-Version})
Enhances: racket
Breaks: plt-scheme-doc (<<5.0~)
Replaces: plt-scheme-doc (<<5.0~)
Provides: plt-scheme-doc
Description: extensible programming language in the Scheme family (documentation)
 This package includes all of the documentation for Racket.

=== debian/rules ===
#!/usr/bin/make -f

DEB_CFLAGS_MAINT_APPEND := -O2
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
include debian/racket-arch.mk

export DEB_CFLAGS_MAINT_APPEND
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_CONFIGURE_SCRIPT := $(CURDIR)/src/configure
MZDYN := mzdyn3m.o

# keep the collect build from using every available core, unless 
# explicitly enabled.
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    ifeq ($(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS),64)
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    else
	NUMJOBS = 1
    endif
else
    NUMJOBS = 1
endif

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    DEB_CONFIGURE_EXTRA_FLAGS += --enable-noopt
endif

# Support for generating ".orig.tar.gz" from git

SOURCEPKG=$(shell dpkg-parsechangelog | sed  -n 's/^Source: \(.*\)/\1/p')
UPSTREAM=$(shell dpkg-parsechangelog |  sed -n 's/^Version: \(.*\)-[^-]*/\1/p')
ORIG=${SOURCEPKG}_${UPSTREAM}.orig.tar.gz

DEB_MAKE_ENVVARS += HOME=/nonexistant PLT_SETUP_OPTIONS="-j $(NUMJOBS) $(PLT_EXTRA)"

DEB_BUILDDIR := $(DEB_SRCDIR)/build

DEB_DH_INSTALL_ARGS_racket-common := -X${RACKET_ARCH} -X$(MZDYN) -X/tests/
DEB_DH_INSTALL_ARGS_racket-doc := -Xrelease
DEB_DH_COMPRESS_ARGS := -X.sxref -X.sqlite

# don't compress rkt source files since some are needed for
# docs such as the quick.scrbl example and blueboxes.rktd files
DEB_COMPRESS_EXCLUDE_ALL := .scrbl .rkt .rktd

DEB_DH_BUILDDEB_ARGS := -- -Zxz

# do not strip mzscheme, as this causes it to stop working
# do not strip mred, as this fails on some arches
DEB_DH_STRIP_ARGS_racket := -Xbin/mzscheme -Xbin/mred

DEB_MAKE_INSTALL_TARGET= no-run

common-install-arch:: do-install-arch
common-install-indep:: do-install-indep

do-install-arch: PLT_EXTRA=--no-docs --no-zo
do-install-arch:
	$(DEB_MAKE_ENVVARS) $(MAKE) -C $(DEB_BUILDDIR) install DESTDIR=$(CURDIR)/debian/tmp
	rm -f $(CURDIR)/debian/tmp/usr/bin/planet

do-install-indep: PLT_EXTRA=--no-launcher --no-install --no-post-install
do-install-indep:
	$(DEB_MAKE_ENVVARS) $(MAKE) -C $(DEB_BUILDDIR) install DESTDIR=$(CURDIR)/debian/tmp

cleanbuilddir/racket::
	rm -rf build
	rm -rf include # This got created at build-time
	rm -f debian/mzconfig.h debian/racket-arch.mk

debian/racket-arch.mk: debian/racket-arch.c
	touch debian/mzconfig.h && cpp -Isrc -Idebian -o - $< | tail -1 > $@

get-orig-source:
	git archive --format=tar --prefix=racket-${UPSTREAM}/ upstream/${UPSTREAM} | gzip -9 > ../${ORIG}

PATCH_EXPORT_SCRIPT = /usr/share/gitpkg/hooks/quilt-patches-deb-export-hook

export-patches: 
	[ ! -r debian/patches ] || \
	grep "^\#.*$(notdir $(PATCH_EXPORT_SCRIPT))" debian/patches/series
	rm -rf debian/patches
	bash $(PATCH_EXPORT_SCRIPT)

.PHONY: git-orig-source export-patches

## racket 7.8+dfsg1

=== src/cs/Makefile ===
--- 
+++ 
@@ -4,19 +4,27 @@
 RACKET = ../../bin/racket
 SCHEME = scheme
 
-# Controls whether Racket layers are built as unsafe:
+# Controls whether Racket layers are built as unsafe; beware that
+# building some Racket libraries using safe mode may require setting
+# `PLT_CS_COMPILE_LIMIT` to 1000 (instead of 10000):
 UNSAFE_COMP = --unsafe
 
 # Controls whether compiled code is compressed:
 COMPRESS_COMP = # --compress
 
-# Controls whether Racket layers are built with expression-level debugging:
+# Controls whether Racket layers are built with expression-level
+# debugging; use "--debug" for expression-level information or
+# "--srcloc" for procedure-level source locations:
 DEBUG_COMP = # --debug
 
-COMPILE_FILE = $(SCHEME) --script compile-file.ss $(UNSAFE_COMP) $(COMPRESS_COMP) $(DEBUG_COMP) --dest "$(BUILDDIR)"
+# For cross-compiling, set `CROSS_COMP` to `-m <machine>`, where
+# the Chez Scheme directory must have "<machine>/s/xpatch":
+CROSS_COMP =
+
+COMPILE_FILE = $(SCHEME) --script compile-file.ss $(UNSAFE_COMP) $(COMPRESS_COMP) $(DEBUG_COMP) $(CROSS_COMP) --dest "$(BUILDDIR)"
 COMPILE_FILE_DEPS = compile-file.ss include.ss place-register.ss 
 
-RACKET_SETUP_ARGS = ../../bin/racket ../../bin/racket ../collects ../etc 0 true false 0 ""
+RACKET_SETUP_ARGS = false ../../bin/racket ../../bin/racket ../collects ../etc 0 true false 0 ""
 
 PRIMITIVES_TABLES = primitive/kernel.ss primitive/unsafe.ss primitive/flfxnum.ss \
                     primitive/paramz.ss primitive/extfl.ss primitive/network.ss \
@@ -38,23 +46,30 @@
 CONVERT_RACKET = $(RACKET) -l- setup --chain ../setup-go.rkt $(BUILDDIR)compiled
 CONVERT = $(CONVERT_RACKET) '(CONVERTED)' $(BUILDDIR)compiled/convert.d convert.rkt $(UNSAFE_COMP)
 
+# This extension is for libraries, and it changes for cross builds:
+CSO = so
+
 # Depenency chain for ".so" files:
-RUMBLE_DEPS = $(BUILDDIR)chezpart.so
-THREAD_DEPS = $(RUMBLE_DEPS) $(BUILDDIR)rumble.so
-IO_DEPS = $(THREAD_DEPS) $(BUILDDIR)thread.so
-REGEXP_DEPS = $(IO_DEPS) $(BUILDDIR)io.so
-SCHEMIFY_DEPS = $(REGEXP_DEPS) $(BUILDDIR)regexp.so
-LINKLET_DEPS = $(SCHEMIFY_DEPS) $(BUILDDIR)schemify.so
-EXPANDER_DEPS = $(LINKLET_DEPS) $(BUILDDIR)linklet.so
-MAIN_DEPS = $(EXPANDER_DEPS) $(BUILDDIR)expander.so
+RUMBLE_DEPS = $(BUILDDIR)chezpart.$(CSO)
+THREAD_DEPS = $(RUMBLE_DEPS) $(BUILDDIR)rumble.$(CSO)
+IO_DEPS = $(THREAD_DEPS) $(BUILDDIR)thread.$(CSO)
+REGEXP_DEPS = $(IO_DEPS) $(BUILDDIR)io.$(CSO)
+SCHEMIFY_DEPS = $(REGEXP_DEPS) $(BUILDDIR)regexp.$(CSO)
+LINKLET_DEPS = $(SCHEMIFY_DEPS) $(BUILDDIR)schemify.$(CSO)
+EXPANDER_DEPS = $(LINKLET_DEPS) $(BUILDDIR)linklet.$(CSO)
+MAIN_DEPS = $(EXPANDER_DEPS) $(BUILDDIR)expander.$(CSO)
 
 all:
 	$(MAKE) rktio
 	$(MAKE) rktl
 	$(MAKE) $(BUILDDIR)racket.so
 
-expander-demo: $(BUILDDIR)expander.so demo/expander.ss ../../bin/racket
-	$(SCHEME) $(EXPANDER_DEPS) $(BUILDDIR)expander.so demo/expander.ss
+CROSS_TARGET = all
+cross:
+	$(MAKE) $(CROSS_TARGET) CSO=$(HOST) CROSS_COMP="--xpatch $(XPATCH)"
+
+expander-demo: $(BUILDDIR)expander.$(CSO) demo/expander.ss ../../bin/racket
+	$(SCHEME) $(EXPANDER_DEPS) $(BUILDDIR)expander.$(CSO) demo/expander.ss
 
 run: $(BUILDDIR)main.so ../../bin/racket
 	$(SCHEME) --script $(BUILDDIR)main.so $(RACKET_SETUP_ARGS) $(ARGS)
@@ -71,7 +86,9 @@
 $(BUILDDIR)racket.so: $(BUILDDIR)main.so $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) --whole-program $(BUILDDIR)racket.so $(BUILDDIR)main.wpo
 
-$(BUILDDIR)main.so: $(MAIN_DEPS) main.sps $(COMPILE_FILE_DEPS)
+MAIN_SRCS = main/help.ss
+
+$(BUILDDIR)main.so: $(MAIN_DEPS) main.sps $(MAIN_SRCS) $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) main.sps $(MAIN_DEPS)
 
 strip:
@@ -90,7 +107,7 @@
 	mkdir -p ../../bin
 	touch ../../bin/racket
 
-$(BUILDDIR)expander.so: expander.sls $(BUILDDIR)compiled/expander.scm $(PRIMITIVES_TABLES) $(EXPANDER_DEPS) $(COMPILE_FILE_DEPS)
+$(BUILDDIR)expander.$(CSO): expander.sls expander/env.ss $(BUILDDIR)compiled/expander.scm $(PRIMITIVES_TABLES) $(EXPANDER_DEPS) $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) expander.sls $(EXPANDER_DEPS)
 
 $(BUILDDIR)compiled/expander.scm: $(BUILDDIR)compiled/expander.rktl $(CONVERT_DEPS)
@@ -102,21 +119,23 @@
 expander-rktl:
 	$(MAKE) bounce BOUNCE_DIR=../expander BOUNCE_TARGET=expander-src BUILDDIR="../cs/"
 
-linklet-demo: $(BUILDDIR)linklet.so
-	$(SCHEME) $(LINKLET_DEPS) $(BUILDDIR)linklet.so demo/linklet.ss
-
-LINKLET_SRCS = linklet/read.ss \
+linklet-demo: $(BUILDDIR)linklet.$(CSO)
+	$(SCHEME) $(LINKLET_DEPS) $(BUILDDIR)linklet.$(CSO) demo/linklet.ss
+
+LINKLET_SRCS = linklet/version.ss \
+               linklet/read.ss \
                linklet/write.ss \
+               linklet/check.ss \
                linklet/performance.ss \
                linklet/annotation.ss \
                linklet/compress.ss \
-               linklet/db.ss
-
-$(BUILDDIR)linklet.so: linklet.sls $(LINKLET_SRCS) $(LINKLET_DEPS) $(COMPILE_FILE_DEPS)
+               linklet/cross-compile.ss
+
+$(BUILDDIR)linklet.$(CSO): linklet.sls $(LINKLET_SRCS) $(LINKLET_DEPS) $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) linklet.sls $(LINKLET_DEPS)
 
 
-$(BUILDDIR)schemify.so: schemify.sls $(BUILDDIR)compiled/schemify.scm $(BUILDDIR)compiled/known.scm $(SCHEMIFY_DEPS) $(COMPILE_FILE_DEPS)
+$(BUILDDIR)schemify.$(CSO): schemify.sls $(BUILDDIR)compiled/schemify.scm $(BUILDDIR)compiled/known.scm $(SCHEMIFY_DEPS) $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) schemify.sls $(SCHEMIFY_DEPS)
 
 $(BUILDDIR)compiled/schemify.scm: $(BUILDDIR)compiled/schemify.rktl $(CONVERT_DEPS)
@@ -140,10 +159,10 @@
 	$(MAKE) bounce BOUNCE_DIR=../schemify BOUNCE_TARGET=known-src BUILDDIR="../cs/"
 
 
-regexp-demo: $(BUILDDIR)regexp.so
-	$(SCHEME) $(REGEXP_DEPS) $(BUILDDIR)regexp.so demo/regexp.ss
-
-$(BUILDDIR)regexp.so: $(BUILDDIR)compiled/regexp.scm regexp.sls $(REGEXP_DEPS) $(COMPILE_FILE_DEPS)
+regexp-demo: $(BUILDDIR)regexp.$(CSO)
+	$(SCHEME) $(REGEXP_DEPS) $(BUILDDIR)regexp.$(CSO) demo/regexp.ss
+
+$(BUILDDIR)regexp.$(CSO): $(BUILDDIR)compiled/regexp.scm regexp.sls $(REGEXP_DEPS) $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) regexp.sls $(REGEXP_DEPS)
 
 $(BUILDDIR)compiled/regexp.scm: $(BUILDDIR)compiled/regexp.rktl $(CONVERT_DEPS)
@@ -156,10 +175,10 @@
 	$(MAKE) bounce BOUNCE_DIR=../regexp BOUNCE_TARGET=regexp-src BUILDDIR="../cs/"
 
 
-io-demo: $(BUILDDIR)io.so
-	$(SCHEME) $(IO_DEPS) $(BUILDDIR)io.so demo/io.ss
-
-$(BUILDDIR)io.so: $(BUILDDIR)compiled/io.scm io.sls $(IO_DEPS) ../rktio/rktio.rktl $(COMPILE_FILE_DEPS)
+io-demo: $(BUILDDIR)io.$(CSO)
+	$(SCHEME) $(IO_DEPS) $(BUILDDIR)io.$(CSO) demo/io.ss
+
+$(BUILDDIR)io.$(CSO): $(BUILDDIR)compiled/io.scm io.sls $(IO_DEPS) ../rktio/rktio.rktl $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) io.sls $(IO_DEPS)
 
 $(BUILDDIR)compiled/io.scm: $(BUILDDIR)compiled/io.rktl $(CONVERT_DEPS)
@@ -175,10 +194,10 @@
 	$(MAKE) bounce BOUNCE_DIR=../io BOUNCE_TARGET=rktio
 
 
-thread-demo: $(BUILDDIR)thread.so
-	$(SCHEME) $(THREAD_DEPS) $(BUILDDIR)thread.so demo/thread.ss
-
-$(BUILDDIR)thread.so: $(BUILDDIR)compiled/thread.scm thread.sls $(THREAD_DEPS) $(COMPILE_FILE_DEPS)
+thread-demo: $(BUILDDIR)thread.$(CSO)
+	$(SCHEME) $(THREAD_DEPS) $(BUILDDIR)thread.$(CSO) demo/thread.ss
+
+$(BUILDDIR)thread.$(CSO): $(BUILDDIR)compiled/thread.scm thread.sls $(THREAD_DEPS) $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) thread.sls $(THREAD_DEPS)
 
 $(BUILDDIR)compiled/thread.scm: $(BUILDDIR)compiled/thread.rktl $(CONVERT_DEPS)
@@ -198,35 +217,35 @@
 	cd $(BOUNCE_DIR); $(MAKE) RACO="$(RACKET) -N raco -l- raco" $(BOUNCE_TARGET)
 
 
-chaperone-demo: $(BUILDDIR)rumble.so
-	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/chaperone.ss
-
-hash-demo: $(BUILDDIR)rumble.so
-	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/hash.ss
-
-struct-demo: $(BUILDDIR)rumble.so
-	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/struct.ss
-
-control-demo: $(BUILDDIR)rumble.so
-	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/control.ss
-
-foreign-demo: $(BUILDDIR)rumble.so
-	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/foreign.ss
-
-will-demo: $(BUILDDIR)rumble.so
-	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/will.ss
-
-future-demo: $(BUILDDIR)rumble.so
-	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/future.ss
-
-future2-demo: $(BUILDDIR)rumble.so
-	$(SCHEME) $(BUILDDIR)chezpart.so $(BUILDDIR)rumble.so demo/future2.ss
+chaperone-demo: $(BUILDDIR)rumble.$(CSO)
+	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/chaperone.ss
+
+hash-demo: $(BUILDDIR)rumble.$(CSO)
+	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/hash.ss
+
+struct-demo: $(BUILDDIR)rumble.$(CSO)
+	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/struct.ss
+
+control-demo: $(BUILDDIR)rumble.$(CSO)
+	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/control.ss
+
+foreign-demo: $(BUILDDIR)rumble.$(CSO)
+	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/foreign.ss
+
+will-demo: $(BUILDDIR)rumble.$(CSO)
+	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/will.ss
+
+future-demo: $(BUILDDIR)rumble.$(CSO)
+	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/future.ss
+
+future2-demo: $(BUILDDIR)rumble.$(CSO)
+	$(SCHEME) $(BUILDDIR)chezpart.$(CSO) $(BUILDDIR)rumble.$(CSO) demo/future2.ss
 
 RUMBLE_SRCS = rumble/define.ss \
               rumble/virtual-register.ss \
+              rumble/layout.ss \
               rumble/check.ss \
 	      rumble/syntax-rule.ss \
-	      rumble/letrec.ss \
               rumble/constant.ss \
               rumble/hash-code.ss \
               rumble/struct.ss \
@@ -237,6 +256,9 @@
               rumble/object-name.ss \
               rumble/arity.ss \
               rumble/intmap.ss \
+              rumble/patricia.ss \
+              rumble/hamt-stencil.ss \
+              rumble/hamt-vector.ss \
               rumble/hash.ss \
               rumble/datum.ss \
 	      rumble/lock.ss \
@@ -244,17 +266,20 @@
               rumble/thread-cell.ss \
               rumble/parameter.ss \
               rumble/begin0.ss \
+              rumble/value.ss \
               rumble/pthread.ss \
               rumble/control.ss \
               rumble/interrupt.ss \
               rumble/engine.ss \
               rumble/source.ss \
               rumble/error.ss \
+              rumble/error-rewrite.ss \
               rumble/srcloc.ss \
               rumble/boolean.ss \
               rumble/bytes.ss \
               rumble/string.ss \
               rumble/char.ss \
+              rumble/char-range.ss \
               rumble/symbol.ss \
               rumble/list.ss \
               rumble/vector.ss \
@@ -277,21 +302,23 @@
               rumble/place.ss \
               rumble/errno-data.ss \
               rumble/foreign.ss \
+              rumble/async-callback.ss \
               rumble/future.ss \
               rumble/version.ss \
               rumble/inline.ss \
               ../racket/src/schvers.h
 
-$(BUILDDIR)rumble.so: $(RUMBLE_DEPS) rumble.sls $(RUMBLE_SRCS) $(COMPILE_FILE_DEPS)
+$(BUILDDIR)rumble.$(CSO): $(RUMBLE_DEPS) rumble.sls $(RUMBLE_SRCS) $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) rumble.sls $(RUMBLE_DEPS)
 
-$(BUILDDIR)chezpart.so: chezpart.sls $(COMPILE_FILE_DEPS)
+$(BUILDDIR)chezpart.$(CSO): chezpart.sls $(COMPILE_FILE_DEPS)
 	$(COMPILE_FILE) chezpart.sls
 
 clean:
+	rm -f chezpart.$(CSO) rumble.$(CSO) regexp.$(CSO) io.$(CSO) linklet.$(CSO) expander.$(CSO) schemify.$(CSO)
 	rm -f chezpart.so rumble.so regexp.so io.so linklet.so expander.so schemify.so
 	rm -f chezpart.wpo rumble.wpo regexp.wpo io.wpo linklet.wpo expander.wpo schemify.wpo
-	rm -f thread.so thread.wpo main.wpo main.so
+	rm -f thread.$(CSO) thread.wpo main.wpo main.so
 	rm -rf compiled
 
 
@@ -311,11 +338,3 @@
 -include compiled/schemify.d
 -include compiled/known.d
 
-# These dependencies are needed when "cs/c" drives the makefile
--include $(BUILDDIR)compiled/convert.d
-
-#\
-!endif
-
-# \
-!include $(BUILDDIR)compiled/convert.d

=== debian/changelog ===
racket (7.8+dfsg1-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Ensure building with -O2 to work around a misbuild on ppc64el which
    defaults to -O3.
    - Build with gcc-9 to work around failure to build on s390x

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 27 Aug 2020 10:21:12 +0100

racket (7.8+dfsg1-1) unstable; urgency=medium

  * Update to new upstream version 7.8+dfsg1.

 -- David Bremner <bremner@debian.org>  Mon, 03 Aug 2020 16:48:09 -0300

racket (7.6+dfsg1-3) unstable; urgency=medium

  * Restore upstream commit 17bc6262938f, try a different armhf gmp fix
    from Paulo Matos (upstream commit 392dc33ce)

 -- David Bremner <bremner@debian.org>  Wed, 22 Apr 2020 11:27:27 -0300

racket (7.6+dfsg1-2) unstable; urgency=medium

  * Revert upstream commit 17bc6262938f (Closes: #948789). This might or
    might not re-introduce numerical problems on armhf
    (https://github.com/racket/racket/issues/2773). Reports welcome.
  * Switch to debrebase and (hopefully dgit) for maintenence.

 -- David Bremner <bremner@debian.org>  Wed, 15 Apr 2020 18:56:52 -0300

racket (7.6+dfsg1-1) unstable; urgency=medium

  * New upstream bugfix release
  * Patch from Asumu to enable useprefix (needed for 7.6)

 -- David Bremner <bremner@debian.org>  Fri, 13 Mar 2020 20:58:28 -0300

racket (7.5+dfsg2-1) unstable; urgency=medium

  * New upstream bugfix release.
  * Drop openssl patch, upstream now recognizes 1.0.2

 -- David Bremner <bremner@debian.org>  Mon, 30 Dec 2019 17:47:51 -0400

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  libfreetype6-dev, libjpeg-dev, libpango1.0-dev, libpng-dev, libssl-dev,
  libxaw7-dev, xbitmaps, libxft-dev, libgl1-mesa-dev | libgl-dev,
  libglu1-mesa-dev | libglu-dev, libx11-dev, libxrender-dev, libcairo2-dev,
- sqlite3
+ sqlite3, gcc-9, g++-9
 Vcs-Git: https://salsa.debian.org/bremner/racket
 Vcs-Browser: https://salsa.debian.org/bremner/racket
 Homepage: https://www.racket-lang.org/

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+export CC=gcc-9
+export CXX=g++-9
 
 DEB_CFLAGS_MAINT_APPEND := -O2
 include /usr/share/cdbs/1/rules/debhelper.mk
@@ -25,6 +28,10 @@
 ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
     DEB_CONFIGURE_EXTRA_FLAGS += --enable-noopt
 endif
+
+# Explicitly enable useprefix for unix-style build (needed for v7.6)
+# See https://github.com/racket/racket/issues/3046
+DEB_CONFIGURE_EXTRA_FLAGS += --enable-useprefix
 
 # Support for generating ".orig.tar.gz" from git
